/***************************************************************************
                          genericsignalmanager.h  -  description
                             -------------------
    begin                : jue jul 10 2003
    copyright            : (C) 2003 by Napsis S.L.
    email                : support@napsis.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GENERICSIGNALMANAGER_H
#define GENERICSIGNALMANAGER_H



/**
*    Generic signal manager Class tries to provide a flexible way to connect objects with generic signals.
*    This class has all the logic to mantain the relationship between the object that emits the signals
*    and the objects that receives the signals.
*    @author Carlos Manzanedo
*/
#include <qobject.h>
#include <qptrlist.h>

#include "hlist.h"

class QString;

class GenericSignalNode{
public:
     QString signal_name;
     HList<QObject> object_list;
};

class GenericSignalManager : public QObject  {
     Q_OBJECT
//class GenericSignalManager{
public: 
     GenericSignalManager();
     ~GenericSignalManager();

public slots:

          
     bool registerGenericSignal(const QString& signal_name, QObject *object);
     bool registerGenericDataSignal(const QString& signal_name, QObject *object);

     bool unregisterGenericSignal(const QString& signal_name, QObject *object);
     bool unregisterGenericDataSignal(const QString& signal_name, QObject *object);

     bool attachToGenericSignal(const QString& signal_name,QObject *object);
     bool attachToGenericDataSignal(const QString& signal_name, QObject *object);

     bool deattachGenericSignal(const QString& signal_name,QObject *object);
     bool deattachGenericDataSignal(const QString& signal_name,QObject *object);     
          
protected:
     int findObjectAtSignalName(const QString& _signal_name,HList<GenericSignalNode> *l,QObject *object);

     HList<GenericSignalNode> *list;
     HList<GenericSignalNode> *data_list;
     HList<GenericSignalNode> *attached_list;
     HList<GenericSignalNode> *attached_data_list; 

};



#endif
