/***************************************************************************
                          bsladvancedorderwidget.h  -  description
                             -------------------
    begin                 : mon Jun 2 2003
    copyright          : (C) 2003 by Napsis S.L.
    email                 : carlos@napsis.com

@author Jose Ignacio Ferrero-Carrera
modified by Carlos Manzanedo Rueda

%LICENCIA%
 ***************************************************************************/

#ifndef BSLADVANCEDORDERWIDGET_H
#define BSLADVANCEDORDERWIDGET_H

#include <liblinuxbar/hlist.h>
#include <liblinuxbar/genericsignalmanager.h>

#include <qframe.h>

class BslOrderWidget;
class QGridLayout;
class QBoxLayout;
class XmlConfig;
class QFrame;
class QPushButton;

class BslAdvancedOrderWidget : public QFrame  {
        Q_OBJECT
public: 
        BslAdvancedOrderWidget(QWidget *parent=0, const char *name=0, GenericSignalManager *gsignal_manager=0);
        ~BslAdvancedOrderWidget();
        BslOrderWidget *getOrder();

public slots:
        void exitMainWindowSlot();
        void deleteReceiptSlot();
        void dataChangedSlot(XmlConfig *xml);        

    
signals:
        void dataChanged(XmlConfig *xml);
        void genericDataSignal(const QString& signal_name,XmlConfig *xml);
        void genericSignal(const QString& signal_name);

protected:
    void parseXmlDescription(GenericSignalManager *gsignal_manager);

    QBoxLayout *layout;
    QGridLayout *frame_layout;
    BslOrderWidget *order;
    QFrame *buttons_container;
    HList<QPushButton> *widgets;
};

#endif
