/***************************************************************************
                          bslmenupage.h  -  description
                             -------------------
    begin                : Tue Sep 9 2003
    copyright            : (C) 2004 by Napsis S.L.
    email                : carlos@napsis.com
***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BSLMENUPAGE_H
#define BSLMENUPAGE_H

#include <qframe.h>
#include <qwidget.h>
#include <qptrlist.h>
#include <qdict.h>

/**
  *@author Carlos Manzanedo Rueda
  */

enum LAYOUT {GRID=0, VBOX, HBOX};

class QLayout;

class BslMenuPage : public QFrame  {
Q_OBJECT
  public: 
    BslMenuPage(QWidget *parent=0, const char *name=0);
    ~BslMenuPage();
    void setDefaultLayout(LAYOUT layout, int row=1, int col=1);
    LAYOUT defaultLayout();
    void addWidget(QWidget *w, QString name);
    void addWidget(QWidget *w, QString name, int index);
    void addWidget(QWidget *w, QString name, int row, int col);

  private:
    void setGridLayoutAsDefault(int row, int col);
    void setVBoxLayoutAsDefault();
    void setHBoxLayoutAsDefault();

  private:
    LAYOUT defLayout;
    QLayout *frame_layout;
    QPtrList<QWidget> widgetList;
    QDict<QWidget> widgetDict;
};

#endif
