/***************************************************************************
                          bslmenustack.h  -  description
                             -------------------
    begin                : Mon Jul 7 2003
    copyright            : (C) 2004 by Napsis S.L.
    email                : carlos@napsis.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BSLMENUSTACK_H
#define BSLMENUSTACK_H

#include <qwidgetstack.h>
#include <qwidget.h>
#include <qptrlist.h>
#include <qdict.h>
#include <qlayout.h>


#include <liblinuxbar/genericsignalmanager.h>


class XmlConfig;

/**
  *@author Carlos Manzanedo Rueda
  */


class BslMenuStack : public QWidgetStack  {
	Q_OBJECT
public: 
	BslMenuStack(GenericSignalManager *_gsignal_manager,QWidget *parent=0, const char *name=0);
	BslMenuStack(QWidget *parent=0, const char *name=0);
	~BslMenuStack();

	virtual void addPage(QWidget *page, QString name);
	virtual QWidget *currentPage();
	virtual bool isMenuPage();
	virtual bool isPage();
	virtual int numPages();

public slots:
	virtual void setCurrentPage(QString name);
	virtual void setCurrentPage(int pageIndex);

	virtual void genericDataSignalSlot(const QString& signal_name,XmlConfig *xml);
	virtual void genericSignalSlot(const QString& signal_name);

protected  :
	void init();

	QVBoxLayout *layout;
	QPtrList<QWidget> pagesList;
	QDict<QWidget> pagesDict;
	GenericSignalManager *gsignal_manager;
};

#endif
