/***************************************************************************
                          bslorderwidget.h  -  description
                             -------------------
    begin                 : mon Jun 2 2003
    copyright          : (C) 2003 by Napsis S.L.
    email                 : carlos@napsis.com

@author Jose Ignacio Ferrero-Carrera
Modified by Carlos Manzanedo Rueda.

%LICENCIA%
 ***************************************************************************/

#ifndef BSLORDERTABLEWIDGET_H
#define BSLORDERTABLEWIDGET_H
#include <liblinuxbar/hlist.h>
#include <qtable.h>
#include <liblinuxbar/genericsignalmanager.h>

//  Order has the following initial appearance
//  ---------------------------------------------------------------------
//  | UNITS | DESCRIPTION | PRIORITY | TIMESTAMP | TOTAL |
//  ---------------------------------------------------------------------
//  |       |             |          |           |       |
//
//  Columns should be movables and its position its saved in the xml that comtains order
//  description
  
class XmlConfig;
class VisualProduct;
  
class BslOrderTableWidget : public QTable  {
   Q_OBJECT
public:
        BslOrderTableWidget(XmlConfig *xml, QWidget *parent=0, const char *name=0,GenericSignalManager *gsignal_manager=0);
        ~BslOrderTableWidget();

        void usePartialSumsByRow(bool use_it);
        void showColumn(QString name, bool show_it);
        XmlConfig* getLocalXml();

public slots:
        void genericSignalSlot(const QString& signal_name);
        void genericDataSignalSlot(const QString& signal_name,XmlConfig *xml);
        void setDefaultColor();
        void moveUpSelection();
        void moveDownSelection();
        void moveToFirst();
        void moveToLast();
        void clearOrder();
        void reset();
        void delRow();
        void incrementQuantity();
        void decrementQuantity();
        // This slot is used to load an order given in a XML definition
        //void loadProductsInfo(XmlConfig *xml);
        // Called each time a new product is clicked
        void updateProductsInfo(XmlConfig *xml);
        void printSlot();

signals:
        void totalBillSignal(float amount);
        void dataChanged(XmlConfig *xml);
        
protected:
        void parseXmlDescription(XmlConfig *xml);
        void total();
        void buildProductsList();
        QString readOptions(QString optionsDomain);
        void setTimeStamp(const QString &domain);
        void selectLastOrderItem();
        void fillVisualOrderWithProductsList();

        //debug purposes
        void debugVProductList();
        void debug();
    

        // Allow to use a partial sum for each row which currently means units*price
        bool use_partial_sums;
        // Selected row
        int selected_row;
        // Selected column
        int selected_column;
        // Height for rows
        int row_height;
        // Used to manage color state at the gsignal_wrong_product
        int color_state;
        QColor last_color;
        
        // This XML is received each time a product change in the CORE
        XmlConfig *local_products_xml;
        // Selection made in the visual order (table)
        QTableSelection *selection;
        // Here we maintain the internal products list extracted from the XML
        HList<VisualProduct> *products_list;
        // List list holds the column position at visual table
        HList<int> *column_positions_list;
};

#endif
