/***************************************************************************
                          bslorderwidget.h  -  description
                             -------------------
    begin                 : mon Jun 2 2003
    copyright          : (C) 2003 by Napsis S.L.
    email                 : carlos@napsis.com

@author Jose Ignacio Ferrero-Carrera
Modified by Carlos Manzanedo Rueda.

%LICENCIA%
 ***************************************************************************/

#ifndef BSLORDERWIDGET_H
#define BSLORDERWIDGET_H

#include <qframe.h>
#include <liblinuxbar/genericsignalmanager.h>

class BslOrderHeaderWidget;
class BslOrderTableWidget;
class BslOrderTotalWidget;
class QBoxLayout;
class XmlConfig;
  
class BslOrderWidget : public QFrame  {
        Q_OBJECT
public: 
        BslOrderWidget(QWidget *parent=0, const char *name=0,GenericSignalManager *gsignal_manager=0);
//        BslOrderWidget(XmlConfig *xml, QWidget *parent=0, const char *name=0);
        ~BslOrderWidget();

        BslOrderTableWidget *getOrderTable();
        BslOrderHeaderWidget *getOrderHeader();

signals:
        void dataChanged(XmlConfig *xml);
    
public slots:
        void dataChangedSlot(XmlConfig *xml);
    
protected:
        void parseXmlDescription();

        // This is the subcomponent header. It has a photo and the name of the waiter
        BslOrderHeaderWidget *order_header;
        // This subcomponent holds information relative to the products, quantity, name, price, etc.
        BslOrderTableWidget *order_table;
        // This subcomponent shows the total and the currency
        BslOrderTotalWidget *order_total;
        QBoxLayout *layout;
};

#endif
