/***************************************************************************
                          spkeyboard.h  -  description
                             -------------------
    begin                : dom feb 8 2004
    copyright            : (C) 2004 by Napsis S.L.
    email                : carlos@napsis.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SPKEYBOARD_H
#define SPKEYBOARD_H

#include <qobject.h>
#include <qwidget.h>
#include <liblinuxbar/hlist.h>

#include "spkeyboardwidget.h"

/**
  *@author Carlos Manzanedo Rueda
  */

class QSignalMapper;
class QPushButton;

class SpKeyboard : public SpKeyboardWidget{
   Q_OBJECT
public: 
        SpKeyboard(QWidget *parent=0, const char *name=0);
        ~SpKeyboard();

        void init();

public slots:
        void sendEvents(bool on);
        void exitWithEnter(bool on);
        void clearSlot();        
                
protected slots:
        void keyClicked(int);
        void exitSlot();

signals:
        void exitClicked();
        void textChanged(const QString& text);
        void enterPressed(const QString &text);
                      
protected:
        HList<QPushButton> *button_list;
        QSignalMapper *signal_mapper;
        bool send_events;
        QObject *o_parent;
        int state;
        bool may;
        bool exit_with_enter;
};

#endif
